Index: trunk/abdev/BasicCompiler_Common/src/ProcedureImpl.cpp
===================================================================
--- trunk/abdev/BasicCompiler_Common/src/ProcedureImpl.cpp	(revision 184)
+++ trunk/abdev/BasicCompiler_Common/src/ProcedureImpl.cpp	(revision 185)
@@ -21,5 +21,5 @@
 	//パラメータ
 	if(sourceOfParams[i]!='('){
-		throw SmoothieException(1,NULL,nowLine);
+		SmoothieException::Throw(1,NULL,nowLine);
 		return 0;
 	}
@@ -28,5 +28,5 @@
 		//クラスのメンバ関数の場合のみ、デストラクタにパラメータがある場合にエラーをだす
 		if(this->GetName()[0]=='~'){
-			throw SmoothieException(114,NULL,nowLine);
+			SmoothieException::Throw(114,NULL,nowLine);
 			i=JumpStringInPare(sourceOfParams,i);
 		}
@@ -77,5 +77,5 @@
 		if(sw){
 			//配列パラメータ
-			if( isRef == false ) throw SmoothieException(29,NULL,nowLine);
+			if( isRef == false ) SmoothieException::Throw(29,NULL,nowLine);
 			isArray = true;
 
@@ -132,5 +132,5 @@
 
 			if( type.IsNull() ){
-				throw SmoothieException(3,temporary,nowLine);
+				SmoothieException::Throw(3,temporary,nowLine);
 				type.SetBasicType( DEF_PTR_VOID );
 			}
@@ -145,5 +145,5 @@
 		else{
 			type.SetBasicType( Type::GetBasicTypeFromSimpleName(temporary) );
-			throw SmoothieException(-103,temporary,nowLine);
+			SmoothieException::Throw(-103,temporary,nowLine);
 		}
 
@@ -162,5 +162,5 @@
 		else if(sourceOfParams[i]==')') continue;
 		else{
-			throw SmoothieException(1,NULL,nowLine);
+			SmoothieException::Throw(1,NULL,nowLine);
 			break;
 		}
@@ -215,5 +215,5 @@
 			if(sw){
 				//配列パラメータ
-				if( isRef == false ) throw SmoothieException(29,NULL,nowLine);
+				if( isRef == false ) SmoothieException::Throw(29,NULL,nowLine);
 				isArray = true;
 
@@ -260,5 +260,5 @@
 
 				if( type.IsNull() ){
-					throw SmoothieException(3,temporary,nowLine);
+					SmoothieException::Throw(3,temporary,nowLine);
 					type.SetBasicType( DEF_PTR_VOID );
 				}
@@ -266,5 +266,5 @@
 			else{
 				type.SetBasicType( Type::GetBasicTypeFromSimpleName(temporary) );
-				throw SmoothieException(-103,temporary,nowLine);
+				SmoothieException::Throw(-103,temporary,nowLine);
 			}
 
@@ -283,5 +283,5 @@
 			else if(sourceOfParams[i]==')') continue;
 			else{
-				throw SmoothieException(1,NULL,nowLine);
+				SmoothieException::Throw(1,NULL,nowLine);
 				break;
 			}
@@ -297,5 +297,5 @@
 		if( !this->IsFunction() ){
 			// Sub/Macroの場合
-			throw SmoothieException(38,this->GetName(),nowLine);
+			SmoothieException::Throw(38,this->GetName(),nowLine);
 		}
 
@@ -304,5 +304,5 @@
 				this->GetName()[0]=='~'){
 				//クラスのコンストラクタ、デストラクタがFunction定義の場合はエラーをだす
-				throw SmoothieException(115,NULL,nowLine);
+				SmoothieException::Throw(115,NULL,nowLine);
 			}
 		}
@@ -327,5 +327,5 @@
 				}
 				Type::StringToType( temporary, this->returnType );
-				if( this->returnType.IsNull() ) throw SmoothieException(3,temporary,nowLine);
+				if( this->returnType.IsNull() ) SmoothieException::Throw(3,temporary,nowLine);
 
 				sw_as=1;
@@ -335,5 +335,5 @@
 
 		if(!sw_as){
-			throw SmoothieException(-104,this->GetName().c_str(),nowLine);
+			SmoothieException::Throw(-104,this->GetName().c_str(),nowLine);
 
 			this->returnType.SetBasicType( DEF_DOUBLE );
@@ -412,5 +412,5 @@
 	//パラメータ
 	if(sourceOfParams[i]!='('){
-		throw SmoothieException(1,NULL,nowLine);
+		SmoothieException::Throw(1,NULL,nowLine);
 		return 0;
 	}
@@ -462,5 +462,5 @@
 		if(sw){
 			//配列パラメータ
-			if( isRef == false ) throw SmoothieException(29,NULL,nowLine);
+			if( isRef == false ) SmoothieException::Throw(29,NULL,nowLine);
 			isArray = true;
 
@@ -508,5 +508,5 @@
 
 			if( type.IsNull() ){
-				throw SmoothieException(3,temporary,nowLine);
+				SmoothieException::Throw(3,temporary,nowLine);
 				type.SetBasicType( DEF_PTR_VOID );
 			}
@@ -514,5 +514,5 @@
 		else{
 			type.SetBasicType( Type::GetBasicTypeFromSimpleName(temporary) );
-			throw SmoothieException(-103,temporary,nowLine);
+			SmoothieException::Throw(-103,temporary,nowLine);
 		}
 
@@ -531,5 +531,5 @@
 		else if(sourceOfParams[i]==')') continue;
 		else{
-			throw SmoothieException(1,NULL,nowLine);
+			SmoothieException::Throw(1,NULL,nowLine);
 			break;
 		}
@@ -560,5 +560,5 @@
 				}
 				Type::StringToType( temporary, this->returnType );
-				if( this->returnType.IsNull() ) throw SmoothieException(3,temporary,nowLine);
+				if( this->returnType.IsNull() ) SmoothieException::Throw(3,temporary,nowLine);
 
 				sw_as=1;
@@ -585,5 +585,5 @@
 	//パラメータ
 	if(sourceOfParams[i]!='('){
-		throw SmoothieException(1,NULL,nowLine);
+		SmoothieException::Throw(1,NULL,nowLine);
 		return 0;
 	}
@@ -634,5 +634,5 @@
 		if(sw){
 			//配列パラメータ
-			if( isRef == false ) throw SmoothieException(29,NULL,nowLine);
+			if( isRef == false ) SmoothieException::Throw(29,NULL,nowLine);
 			isArray = true;
 
@@ -679,5 +679,5 @@
 
 			if( type.IsNull() ){
-				throw SmoothieException(3,temporary,nowLine);
+				SmoothieException::Throw(3,temporary,nowLine);
 				type.SetBasicType( DEF_PTR_VOID );
 			}
@@ -685,5 +685,5 @@
 		else{
 			type.SetBasicType( Type::GetBasicTypeFromSimpleName(temporary) );
-			throw SmoothieException(-103,temporary,nowLine);
+			SmoothieException::Throw(-103,temporary,nowLine);
 		}
 
@@ -702,5 +702,5 @@
 		else if(sourceOfParams[i]==')') continue;
 		else{
-			throw SmoothieException(1,NULL,nowLine);
+			SmoothieException::Throw(1,NULL,nowLine);
 			break;
 		}
@@ -731,5 +731,5 @@
 				}
 				Type::StringToType( temporary, this->returnType );
-				if( this->returnType.IsNull() ) throw SmoothieException(3,temporary,nowLine);
+				if( this->returnType.IsNull() ) SmoothieException::Throw(3,temporary,nowLine);
 
 				sw_as=1;
@@ -749,5 +749,5 @@
 		if( this->ReturnType().IsNull() ){
 			// 戻り値がない
-			throw SmoothieException(26,this->GetName(),nowLine);
+			SmoothieException::Throw(26,this->GetName(),nowLine);
 		}
 	}
@@ -755,5 +755,5 @@
 		if( !this->ReturnType().IsNull() ){
 			// Sub定義なのに、戻り値がある
-			throw SmoothieException(38,this->GetName(),nowLine);
+			SmoothieException::Throw(38,this->GetName(),nowLine);
 		}
 	}